/*******************************************************************************
 * I9 TECHNOLOGIES CONFIDENTIAL
 * __________________
 * Copyright © 2013 i9 Technologies 
 * All Rights Reserved.
 * 
 * NOTICE:  All information contained herein is, and remains the property 
 * of i9 Technologies and its suppliers, if any.  The intellectual and technical 
 * concepts contained herein are proprietary to i9 Technologies and its 
 * suppliers and may be covered by U.S. and Foreign Patents, patents in 
 * process, and are protected by trade secret or copyright law. Dissemination 
 * of this information or reproduction of this material is strictly forbidden 
 * unless prior written permission is obtained from i9 Technologies.
 ******************************************************************************/
package com.xmlnamespace.panel.vaadin.ui;

import java.util.Date;

import com.vaadin.ui.Label;
import com.xmlnamespace.panel.vaadin.shared.ui.TimerLabelRpc;
import com.xmlnamespace.panel.vaadin.shared.ui.TimerLabelServerRpc;

/**
 * Timer Label Widget.
 */
public class TimerLabel extends Label {

    /** The Constant serialVersionUID. */
    private static final long serialVersionUID = -6484207618140041824L;
    
    private long startTime;
    
    private TimerLabelServerRpc rpc = new TimerLabelServerRpc() {
        private static final long serialVersionUID = 2604008861067427170L;

        @Override
        public void updateTime() {
            setStartTime(startTime);
        }
    };

    /**
     * Instantiates a new timer label.
     */
    public TimerLabel() {
        setStartTime(new Date().getTime());
        
        registerRpc(rpc);
    }

    /**
     * Instantiates a new timer.
     * 
     * @param startTime
     *            the start seconds
     */
    public TimerLabel(final long startTime) {
        setStartTime(startTime);

        registerRpc(rpc);
    }
    
    /* (non-Javadoc)
     * @see com.vaadin.ui.Label#attach()
     */
    @Override
    public void attach() {
        super.attach();
        
        setStartTime(startTime);
    }

    /**
     * Sets the start seconds.
     * 
     * @param startSeconds
     *            the new start seconds
     */
    public void setStartTime(long startTime) {
        this.startTime = startTime;
        getRpcProxy(TimerLabelRpc.class).setCurrentTime(new Date().getTime() - startTime);
    }

}
